//## begin module%1.4%.codegen_version preserve=yes
//   Read the documentation to learn more about C++ code generator
//   versioning.
//## end module%1.4%.codegen_version

//## begin module%4884A01B03CB.cm preserve=no
//	  %X% %Q% %Z% %W%
//## end module%4884A01B03CB.cm

//## begin module%4884A01B03CB.cp preserve=no
//## end module%4884A01B03CB.cp

//## Module: ExpInt%4884A01B03CB; Package body
//## Subsystem: XSUtil::Numerics%41E6D0F3003C
//## Source file: /local/data/xerxes1/gordon/headas/Xspec/src/XSUtil/Numerics/ExpInt.cxx

//## begin module%4884A01B03CB.additionalIncludes preserve=no
//## end module%4884A01B03CB.additionalIncludes

//## begin module%4884A01B03CB.includes preserve=yes
#include <cmath>
//## end module%4884A01B03CB.includes

// ExpInt
#include <XSUtil/Numerics/ExpInt.h>
//## begin module%4884A01B03CB.declarations preserve=no
//## end module%4884A01B03CB.declarations

//## begin module%4884A01B03CB.additionalDeclarations preserve=yes
//## end module%4884A01B03CB.additionalDeclarations


//## Modelname: XSUtil::Numerics%3F6F5A7603D4
namespace Numerics {
    //## begin Numerics%3F6F5A7603D4.initialDeclarations preserve=yes
     // All coefficients are listed in chapter 5 of:
     // M. Abramowitz, I.A. Stegun, "Handbook of Mathematical Functions
     // with Formulas, Graphs, and Mathematical Tables," 
     // U.S. Department of Commerce, 2002
    
     // For 0 <= x <= 1, from E.E. Allen, Mathematical Tables and other 
     // Aids to Computation, vol.8, 240 (1954)
     const Real E1::a[] = {-.57721566,  .99999193, -.24991055,
                            .05519968, -.00976004,  .00107857};
     // For 1 <= x < inf, from C. Hastings, Jr., Approximations for
     // digital computers, Princeton Univ. Press, (1955)
     const Real E1::b[] = { 9.5733223454, 25.6329561486,
                           21.0996530827,  3.9584969228};
     const Real E1::c[] = { 8.5733287401, 18.0590169730,
                            8.6347608925,   .2677737343};
    //## end Numerics%3F6F5A7603D4.initialDeclarations

    // Class Numerics::E1 

    E1::E1()
      //## begin E1::E1%4884A28B00EF_const.hasinit preserve=no
      //## end E1::E1%4884A28B00EF_const.hasinit
      //## begin E1::E1%4884A28B00EF_const.initialization preserve=yes
      //## end E1::E1%4884A28B00EF_const.initialization
    {
      //## begin Numerics::E1::E1%4884A28B00EF_const.body preserve=yes
      //## end Numerics::E1::E1%4884A28B00EF_const.body
    }



    //## Other Operations (implementation)
    Real E1::operator () (const Real x) const
    {
      //## begin Numerics::E1::operator ()%4884A447038D.body preserve=yes
       Real val=0.0;
       const Real x2 = x*x;
       const Real x3 = x2*x;
       const Real x4 = x2*x2;
       if (x <= 1.0)
       {
          val = a[0] + a[1]*x + a[2]*x2 + a[3]*x3 + a[4]*x4 
                + a[5]*x4*x - log(x);
       }
       else
       {
          val = (x4 + c[0]*x3 + c[1]*x2 + c[2]*x + c[3])/
                (x4 + b[0]*x3 + b[1]*x2 + b[2]*x + b[3]);
          val /= x*exp(x);
       }
       return val;
      //## end Numerics::E1::operator ()%4884A447038D.body
    }

    // Additional Declarations
      //## begin Numerics::E1%4884A28B00EF.declarations preserve=yes
      //## end Numerics::E1%4884A28B00EF.declarations

} // namespace Numerics

//## begin module%4884A01B03CB.epilog preserve=yes
//## end module%4884A01B03CB.epilog
